from django.core.cache import cache
from .models import ProductCategory, Classification

def categories_and_classifications(request):
    categories = cache.get('categories')
    classifications = cache.get('classifications')

    if not categories:
        categories = ProductCategory.objects.all()
        cache.set('categories', categories, 3600)  # Cache for 1 hour

    if not classifications:
        classifications = Classification.objects.all()
        cache.set('classifications', classifications, 3600)  # Cache for 1 hour

    return {
        'categories': categories,
        'classifications': classifications,
    }