from django.urls import path
from . import views

urlpatterns = [
    path('', views.Home, name="home"),
    path('store', views.Store, name="store"),
    path('product/<slug:product_slug>/', views.product_detail, name='product_detail'),
    path('cart/', views.Cart, name="cart"),
    path('checkout/', views.Checkout, name="checkout"),
    path('update_item/', views.updateItem, name="update_item"),
    path('process_order/', views.processOrder, name="process_order"),
    # path('<single_slug>', views.single_slug, name="single_slug"),
    path('products/', views.product_list, name='product_list'),
    path('products/<slug:category_slug>/', views.product_list, name='product_list_by_category'),
    path('products/<slug:category_slug>/<slug:classification_slug>/', views.product_list, name='product_list_by_classification'),
]
