from django.db.models.signals import post_save
from django.contrib.auth.models import User
from django.dispatch import receiver
from store.models import Customer


# signal that gets fired after the user is saved
@receiver(post_save, sender=User)
def create_customer(sender, instance, created, **kwargs):
    if created:
        Customer.objects.create(user=instance)


@receiver(post_save, sender=User)
def save_customer(sender, instance, **kwargs):
    # Avoid saving customer during order save operation
    if not hasattr(instance, '_order_save'):
        instance.customer.save()